{$M, 8192,0,0}
USES GMemory, BoyerMo2;

CONST
  BufferSize  = 65000;
  PatternSize = 25;
  MaxCrack    = 20;

TYPE
  PArray = ^TArray;
  TArray = ARRAY[1..BufferSize] OF Byte;

  TByteData = RECORD
      Search : STRING[PatternSize];
     Replace : STRING[PatternSize];
  END;
  TCrackData = RECORD
        Logo : ARRAY[1..4000] OF Byte;
      YCoord : Byte;
  CrackTotal : Byte;
    FileName : STRING[12];
        Data : ARRAY[1..MaxCrack] OF TByteData;
  END;

{$I EC\EC31\EC3_DATA.PAS}

VAR
  InFile       : FILE;
  Index        : Word;
  Readen       : Word;
  FindCount    : Word;
  TotCracks    : Byte;

  Buffer       : PArray;
  SearchText   : STRING;
  ReplaceText  : STRING;
  SearchLength : Byte;
  ShiftTable   : ARRAY[Char] OF Byte;
  ScanBegin    : Word;

  Offset       : LongInt;
  BufferNum    : LongInt;
  InFileSize   : LongInt;
  InFilePos    : LongInt;


PROCEDURE _Write(Str:STRING); ASSEMBLER;
ASM
   LES   SI, Str
   XOR   CX, CX
   MOV   CL, ES:[SI]
   INC   SI
 @Loop:
   MOV   AH, 2
   SEGES LODSB
   MOV   DL, AL
   INT   21h
   LOOP  @Loop
END;

PROCEDURE Msg(St:STRING);
BEGIN
  _Write(St+#13#10);
  dAlloc(Buffer);
  Halt;
END;

PROCEDURE ReplaceBytes(Offset:LongInt);
VAR OldFilePos:LongInt;
BEGIN
  OldFilePos := FilePos(InFile);
  Seek(InFile, Offset);
  {$I-}
    BlockWrite(InFile, ReplaceText[1], Length(ReplaceText));
  {$I+}
  IF IOResult <> 0 THEN Msg('ERROR: Can''t write to '+CrackData.FileName);
  Seek(InFile, OldFilePos);
END;



{---------------------------------------------------------------------------}
PROCEDURE ShowLogo(VAR InBuf); ASSEMBLER;
ASM
  { Change mode }
  MOV AX, 0003h
  INT 10h
  { Move cursor }
  MOV AH, 0Fh
  INT 10h
  MOV AH, 02h
  XOR DL, DL
  MOV DH, CrackData.YCoord
  DEC DH
  INT 10h
  { Show logo }
  PUSH DS
  MOV DX, 0B800h
  LDS SI, InBuf
  MOV ES, DX
  XOR DI, DI
  MOV CX, 2000
 @L1:
  LODSB
  STOSB
  INC DI
  LOOP @L1
  LDS  SI, InBuf
  MOV  ES, DX
  XOR  DI, DI
  ADD  SI, 2000
  MOV  CX, 2000
 @L2:
  INC  DI
  LODSB
  STOSB
  LOOP @L2
  POP  DS
END;




{***************************************************************************}
{******************************* MAIN PROGRAM ******************************}
{***************************************************************************}
BEGIN
  ShowLogo(CrackData.Logo);

  IF CrackData.CrackTotal = 0
    THEN Msg('ERROR: Data not initialized');

  Offset    := 0;
  BufferNum := 0;
  FindCount := 0;

  mAlloc(Buffer, BufferSize); { New(Buffer) }

  (* OpenFile *)
  Assign(InFile, CrackData.FileName);
  {$I-} Reset(InFile,1); {$I+}
  IF IOResult <> 0 THEN Msg('ERROR: Can''t open '+CrackData.FileName);
  (* Search *)
  REPEAT
    {$I-}
      BlockRead(InFile,Buffer^,SizeOf(Buffer^),Readen);
    {$I+}
    IF IOResult <> 0 THEN Msg('ERROR: Can''t read from '+CrackData.FileName);

    IF Readen = 0 THEN Break;

    FOR TotCracks := 1 TO CrackData.CrackTotal DO
    BEGIN
      SearchText  := CrackData.Data[TotCracks].Search;
      ReplaceText := CrackData.Data[TotCracks].Replace;
{      for index := 1 to length(searchtext)
        do write(dectohex(ord(searchtext[index])));
      writeln;}
      Make_Boyer_Moore_Table(SearchText, ShiftTable);
      ScanBegin := 1;
      SearchLength := Length(SearchText);
      REPEAT
        Index := Boyer_Moore_Search(Buffer^,ScanBegin,Readen,SearchText,ShiftTable);
        IF Index > 0 THEN
        BEGIN
          Offset := Pred(Index) + (BufferNum*SizeOf(Buffer^));
          ReplaceBytes(Offset);
{          _Write('$'+DecToHex(Offset)+#13#10);}
          ScanBegin := Index+1;
          Inc(FindCount);
        END
      UNTIL Index = 0;
    END; {FOR}
    Inc(BufferNum);
  UNTIL Readen = 0;
  IF FindCount = 0 THEN Msg('ERROR: Bytes not found. '+CrackData.FileName+' is compressed or cracked already!');
  Msg(CrackData.FileName+' is CRACKED!');
  dAlloc(Buffer); { Dispose(Buffer) }
  Close(InFile);
END.